/* ================================================================================
                                                                                  |
    Little experience: Some animation to capture the attention.                   |
    Author: Impera CMS (http://imperacms.ru)                                      |
    License: Free for any purposes.                                               |
                                                                                  |
================================================================================ */

    /* ============================================================================
    |                                                                             |
    |   Your phrases array here. Each element may be regular string or object.    |
    |                                                                             |
    ============================================================================ */

    var phrases = [ 'We starts!',

                    { text: 'Special offer',
                      info: 'A little description example.' },

                    { text:  'Discount 15%',
                      color: 'magenta',
                      info:  'Another color example.'},

                    { text:  'icon example',
                      color: 'gray',
                      info:  '<img src="example-icon.png" />' },

                    { text:  'link example',
                      color: 'gray',
                      info:  'Read <a href="#">more</a> about this product.' } ];

    /* ============================================================================
    |                                                                             |
    |   Technical variables.                                                      |
    |                                                                             |
    ============================================================================ */

    var spans   = null,
        infos   = null,
        idx     = 0,
        busy    = false;

    /* ============================================================================
    |                                                                             |
    |   Retrieve field of current phrase.                                         |
    |                                                                             |
    ============================================================================ */

    function getPhrase ( field ) {
        if (typeof phrases[idx] != 'object') {
            return field == 'text' ? phrases[idx] : '';
        }
        return field in phrases[idx] ? phrases[idx][field] : '';
    }

    /* ============================================================================
    |                                                                             |
    |   Fill motion area with current phrase.                                     |
    |                                                                             |
    ============================================================================ */

    function updateMotion () {
        var text  = getPhrase('text'),
            color = getPhrase('color'),
            info  = getPhrase('info');
        for (var i = 0; i < spans.length; i++) {
            spans[i].setAttribute('data-title', text);
            spans[i].setAttribute('class', color);
        }
        infos.innerHTML = info;
    }

    /* ============================================================================
    |                                                                             |
    |   Switch to next phrase.                                                    |
    |                                                                             |
    ============================================================================ */

    function nextPhrase () {
        idx++;
        if (idx >= phrases.length) { idx = 0; }
        updateMotion();
    }

    /* ============================================================================
    |                                                                             |
    |   Body onLoad handler.                                                      |
    |                                                                             |
    ============================================================================ */

    function prepareMotion () {
        var area = document.querySelector('.motion');
        if (area) {
            spans = area.querySelectorAll('span');
            infos = area.querySelector('div');
            updateMotion();
            spans[0].addEventListener('animationstart', trackMotion);
            spans[0].addEventListener('animationiteration', trackMotion);
        }
    }

    /* ============================================================================
    |                                                                             |
    |   Control animation iterations.                                             |
    |                                                                             |
    ============================================================================ */

    function trackMotion () {
        if (!busy) {
            busy = true;
            setTimeout(function () {
                nextPhrase();
                busy = false;
            }, 5585);
        }
    }
